<?php
error_reporting(1);
setlocale(LC_ALL,'Czech');

// ---------------------------------------------------------
//                  BLOXXY - search
// ---------------------------------------------------------
//		2004	-	Pavel Moravec	(pavelm@pavelm.net)
//		version 0.9b
//
//		2004	-	Martin ruba	(techblog@seznam.cz)
//		version 0.91b (actual - searching in all groups)
//
//		freeware, beta, copyleft
//		all rights reserved, no responsibility
// ---------------------------------------------------------



// ========== CONFIG ========== //
// It is necessary to set apropriate values!!!

	// absolute path to Bloxxy system files
$absoluteBloxxyPath = "http://www.example.net/bloxxy";

	// relative path from directory with this file to Bloxxy system directory
$relativeBloxxyPath = "./bloxxy";

	// relative path from Bloxxy system directory to data directory
$relativeDataPath = "./data";

	// relative path from directory with this file to direcory with your template
$searchPageTemplate = "./bloxxy/templates/sablona-hledani.html";

  // Suffix of your pages with items
$itmsuf = '.html';

	// div class of the time legend under each found link
$className = "popisek";

  // Generate searchlog file true/false (Keep in mind it's text file so everyone who knows its name can read it!)
$searchlog = false;

  // Searchlog file name
$searchlogfn = 'searchlog.txt';

	// nothing found description
$nothingFound = "Nic nenalezeno";

	// don't know what to query
$nothingtosearch = "<p class = \"komenthlavicka\">Nejdve specifikujte dotaz!</p>";

	// the query must contain more than one character
$toofewcharacters = "<p class = \"komenthlavicka\">Dotaz mus obsahovat vce ne jeden znak!</p>";


// ========== END OF CONFIG PART ========== //
// Do not make any changes under this comment!!!



// ----- Inits

include $relativeBloxxyPath.$relativeDataPath.'/groups.conf';
include $relativeBloxxyPath.$relativeDataPath.'/publications.conf';

$items_file = $relativeBloxxyPath.$relativeDataPath.'/items.conf';


// Makes array with stamps (0) and group ids (1) of each item

  $items = array();
  if (file_exists($items_file)) {
    $its = file($items_file);
    $countOfItms = count($its);
    for ($i=0;$i<$countOfItms;$i++ ) {
      $it = trim($its[$i]);
      if ($it) {
        $it = explode("\t",$it);
        $items[] = $it;
        }
      }
    }




// ========== BEGIN SEARCHING ========== //

// ----- tokenize parameter from http_get
$token = strtok ($hledej," ");
while ($token) {
	$tokensArray[] = $token;
  	$token = strtok (" ");
}
	
// ----- script generates output only if there is any word to search
if ($tokensArray[0] != "" && strlen($hledej)>1) {
	
	//	----- save the words user is searching for into searchedWords variable 
	$t = 0;
	while ($tokensArray[$t] != "") {
		$searchedWords .= $tokensArray[$t].' ';
		$t++;
	}

	// ========== spots search part ========== //	


// ----- Associating groups with them publications
$BlgCount = count($blogs);
for ($ii=0;$ii<$BlgCount;$ii++ ) {
  if (($blogs[$ii]['groups'] != 'all') && !(isset($groupsArray [$blogs[$ii]['groups']]))) {
    $groupsArray [$blogs[$ii]['groups']] = $ii;
  }
}


for ($ii=0;$ii<$countOfItms;$ii++ ) {

$blogid = $items[$ii][1];
$stamp = $items[$ii][0];  
$publid = $groupsArray [$blogid];


// ----- Relative archive path from publications file (array $blogs)
$relarchiv = str_replace(basename($blogs[$publid]["archivdatarelpath"]),'',$blogs[$publid]["archivdatarelpath"]); 
$absoluteArchivePath = $absoluteBloxxyPath.'/'.$relarchiv;  				

			
	//	----- walks through the spotFiles array		
	$i = 0;

  	$filename = $relativeBloxxyPath.'/data/'.$stamp.'.txt';
		$fd = fopen ($filename, "r");
		$spot = fread ($fd, filesize ($filename));

		// ----- examines opened spotFile for presence of words the user is searching for
		$t = 0;
		$found = "true";

		while ($tokensArray[$t] != "") {
			if (!eregi($tokensArray[$t], $spot)) {
   			$found = "false";
			}
			$t++;
		}  
		
			
		// ----- if the words matches, it saves the link
		if ($found == "true") {
			$matchingSpots[] = $spotFiles[$i];
			$date = date("d. m. Y",substr($stamp,0,10));
			$storyTitle = EReg_Replace ("^:* ", "", strtok($spot, "\n"));
		  $storyTitle = trim($storyTitle);

      $storyFilename = ModLink ($storyTitle);
 // Function Modlink's code is at the end of this file. It is necessary to be the same function which is in your index.php file. Better check it! Or if you still had problems with generated filenames contact author.

			$results[$blogid] .= '<li><a href = "'.$absoluteArchivePath.$storyFilename.$itmsuf.'">'.$storyTitle.'</a> - <span class="'.$className.'">'.$date.'</span></li>'."\n";

		}
				
		fclose ($fd);
		$i++;
	
} // end for



	// ----- save the results into spotResults variable	
	if ($results=="") {
		$spotResults = "<ul><li>$nothingFound</li></ul>";
	}
	else {
		reset ($results);
		while (list ($key, $val) = each ($results)) {
    $spotResults = $spotResults.'<h4>Vskyt v rubrice '.$groups[$key].'</h4>'."\n".'<ul>'."\n".$val.'</ul>'."\n\n";
    }
	}
	

} // end of generating results

else {
  $results='';
	if ($tokensArray[0] == "") {
		$errorString = $nothingtosearch;
	}
	else {
		$errorString = $toofewcharacters;
	}
}


// ========== CREATE AN OUTPUT ========== //


// ----- Generating searchlog file, if is permitted at the beginning

if ($searchlog) {

  $line = time()."\t".$searchedWords. "\t". $REMOTE_ADDR . "\t" . $HTTP_USER_AGENT . "\t" . $HTTP_REFERER . "\t" . GetHostByAddr($REMOTE_ADDR) . "\n";
  
  if ($results !=='') {
    $handle = fopen($searchlogfn, "a");
    fwrite($handle,$line);
    fclose($handle);
  } 

}

// ----- reads the template
$filename = $searchPageTemplate;
$fd = fopen ($filename, "r");
$template = fread ($fd, filesize ($filename));
fclose ($fd);

// ----- replaces template keywords
$template = EReg_Replace ("%searched_words%", $searchedWords, $template);
$template = EReg_Replace ("%found_spots%", $spotResults, $template);
$template = EReg_Replace ("%found_comments%", $commentResults, $template);
$template = EReg_Replace ("%error_string%", $errorString, $template);

// ----- this is the final output which goes to browser
echo $template;




function ModLink($fn) {
	$fn = StrTr($fn,
"؝ž",
"eeEErRtTzZuUuUuUiIoOaAsSdDyYcCnNaAlLlLrRoO");

  	$fn = StrToLower($fn);
		$fn = trim($fn);
    $fn = str_replace('@','o',$fn);
    $fn = str_replace('~','-',$fn);
		$fn = str_replace(' ','-',$fn);

		$fn = str_replace(' ','-',$fn);
		
		$Xchars = array('"','&#x201c;','&#x201e;','?','!','.',',','&#x2026;',':','(',')','/','"','\\','<','>');		
		$fn = str_replace($Xchars,'',$fn);


$fn = ereg_replace("&#?([a-zA-Z0-9])+;",'-',$fn);
$fn = ereg_replace("[^a-z0-9\-]",'',$fn);
$fn = ereg_replace('\-+$','',$fn);
$fn = ereg_replace('\-\-+','-',$fn);


    return $fn;
}


?>
